<?php
/**
 * Luxury Interior functions and definitions
 *
 * @package Luxury Interior
 */

/**
 * Set the content width based on the theme's design and stylesheet.
 */

if ( ! function_exists( 'luxury_interior_setup' ) ) :
/**
 * Sets up theme defaults and registers support for various WordPress features.
 *
 * Note that this function is hooked into the after_setup_theme hook, which runs
 * before the init hook. The init hook is too late for some features, such as indicating
 * support post thumbnails.
 */
function luxury_interior_setup() {
	global $luxury_interior_content_width;
	if ( ! isset( $luxury_interior_content_width ) )
		$luxury_interior_content_width = 680;

	load_theme_textdomain( 'luxury-interior', get_template_directory() . '/languages' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( "responsive-embeds" );
	add_theme_support( 'align-wide' );
	add_theme_support( 'woocommerce' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'wp-block-styles');
	add_theme_support( 'custom-header', array(
		'default-text-color' => false,
		'header-text' => false,
	) );
	add_theme_support( 'custom-logo', array(
		'height'      => 100,
		'width'       => 100,
		'flex-height' => true,
	) );
	register_nav_menus( array(
		'primary' => __( 'Primary Menu', 'luxury-interior' ),
	) );
	add_theme_support( 'custom-background', array(
		'default-color' => 'ffffff'
	) );
	add_theme_support( 'html5', array(
		'search-form',
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );
	/*
	 * Enable support for Post Formats.
	 */
	add_theme_support( 'post-formats', array('image','video','gallery','audio',) );

	add_editor_style( 'editor-style.css' );

	global $pagenow;

    if ( is_admin() && 'themes.php' === $pagenow && isset( $_GET['activated'] ) && current_user_can( 'manage_options' ) ) {
        add_action('admin_notices', 'luxury_interior_deprecated_hook_admin_notice');
    }
}
endif; // luxury_interior_setup
add_action( 'after_setup_theme', 'luxury_interior_setup' );

function luxury_interior_the_breadcrumb() {
    echo '<div class="breadcrumb my-3">';

    if (!is_home()) {
        echo '<a class="home-main align-self-center" href="' . esc_url(home_url()) . '">';
        bloginfo('name');
        echo "</a>";

        if (is_category() || is_single()) {
            the_category(' , ');
            if (is_single()) {
                echo '<span class="current-breadcrumb mx-3">' . esc_html(get_the_title()) . '</span>';
            }
        } elseif (is_page()) {
            echo '<span class="current-breadcrumb mx-3">' . esc_html(get_the_title()) . '</span>';
        }
    }

    echo '</div>';
}

function luxury_interior_widgets_init() {
	register_sidebar( array(
		'name'          => __( 'Blog Sidebar', 'luxury-interior' ),
		'description'   => __( 'Appears on blog page sidebar', 'luxury-interior' ),
		'id'            => 'sidebar-1',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget'  => '</aside>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Page Sidebar', 'luxury-interior' ),
		'id'            => 'sidebar-2',
		'description'   => __( 'Add widgets here to appear in your sidebar on pages.', 'luxury-interior' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Sidebar 3', 'luxury-interior' ),
		'id'            => 'sidebar-3',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'luxury-interior' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Shop Page Sidebar', 'luxury-interior' ),
		'description'   => __( 'Appears on shop page', 'luxury-interior' ),
		'id'            => 'woocommerce_sidebar',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget'  => '</aside>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );
	register_sidebar(array(
        'name'          => __('Single Product Sidebar', 'luxury-interior'),
        'description'   => __('Sidebar for single product pages', 'luxury-interior'),
		'id'            => 'woocommerce-single-sidebar',
        'before_widget' => '<aside id="%1$s" class="widget %2$s">',
        'after_widget'  => '</aside>',
        'before_title'  => '<h3 class="widget-title">',
        'after_title'   => '</h3>',
    ));

	$luxury_interior_widget_areas = get_theme_mod('luxury_interior_footer_widget_areas', '4');
	for ($luxury_interior_i=1; $luxury_interior_i <= 4; $luxury_interior_i++) {
		register_sidebar( array(
			'name'          => __( 'Footer Widget ', 'luxury-interior' ) . $luxury_interior_i,
			'id'            => 'footer-' . $luxury_interior_i,
			'description'   => '',
			'before_widget' => '<aside id="%1$s" class="widget %2$s">',
			'after_widget'  => '</aside>',
			'before_title'  => '<h3 class="widget-title">',
			'after_title'   => '</h3>',
		) );
	}
}
add_action( 'widgets_init', 'luxury_interior_widgets_init' );

// Change number of products per row to 4
add_filter('loop_shop_columns', 'luxury_interior_loop_columns');
if (!function_exists('luxury_interior_loop_columns')) {
    function luxury_interior_loop_columns() {
        $colm = get_theme_mod('luxury_interior_products_per_row', 4); // Default to 4 if not set
        return $colm;
    }
}

// Use the customizer setting to set the number of products per page
function luxury_interior_products_per_page($cols) {
    $cols = get_theme_mod('luxury_interior_products_per_page', 9); // Default to 9 if not set
    return $cols;
}
add_filter('loop_shop_per_page', 'luxury_interior_products_per_page', 9);


function luxury_interior_scripts() {
	wp_enqueue_style( 'bootstrap-css', get_template_directory_uri()."/css/bootstrap.css" );
	wp_enqueue_style( 'owl.carousel-css', get_template_directory_uri()."/css/owl.carousel.css" );
	wp_enqueue_style( 'luxury-interior-basic-style', get_stylesheet_uri() );
	wp_enqueue_style( 'luxury-interior-default', get_template_directory_uri()."/css/default.css" );

	require get_parent_theme_file_path( '/inc/color-scheme/custom-color-control.php' );
	wp_add_inline_style( 'luxury-interior-basic-style',$luxury_interior_color_scheme_css );
	wp_enqueue_script( 'owl.carousel-js', get_template_directory_uri(). '/js/owl.carousel.js', array('jquery') );
	wp_enqueue_script( 'bootstrap-js', get_template_directory_uri(). '/js/bootstrap.js', array('jquery') );
	wp_enqueue_script( 'luxury-interior-theme', get_template_directory_uri() . '/js/theme.js' );
	wp_enqueue_style( 'font-awesome-css', get_template_directory_uri()."/css/fontawesome-all.css" );
	wp_enqueue_style( 'luxury-interior-block-style',  get_template_directory_uri(). '/css/blocks.css' );
	wp_enqueue_style('luxury-interior-style', get_stylesheet_uri(), array() );
		wp_style_add_data('luxury-interior-style', 'rtl', 'replace');


	wp_enqueue_style( 'luxury-interior-responsive', get_template_directory_uri()."/css/responsive.css" );
	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}


	
	// font-family
	$luxury_interior_headings_font = esc_html(get_theme_mod('luxury_interior_headings_fonts'));
	$luxury_interior_body_font = esc_html(get_theme_mod('luxury_interior_body_fonts'));

	if ($luxury_interior_headings_font) {
	    wp_enqueue_style('luxury-interior-headings-fonts', 'https://fonts.googleapis.com/css?family=' . urlencode($luxury_interior_headings_font));
	} else {
	    wp_enqueue_style('open-sans-headings', 'https://fonts.googleapis.com/css?family=Open+Sans:ital,wght@0,300;0,400;0,500;0,600;0,700;0,800;1,300;1,400;1,500;1,600;1,700;1,800');
	}

	if ($luxury_interior_body_font) {
	    wp_enqueue_style('luxury-interior-body-fonts', 'https://fonts.googleapis.com/css?family=' . urlencode($luxury_interior_body_font));
	} else {
	    wp_enqueue_style('open-sans-body', 'https://fonts.googleapis.com/css?family=Open+Sans:ital,wght@0,300;0,400;0,500;0,600;0,700;0,800;1,300;1,400;1,500;1,600;1,700;1,800');
	}

}
add_action( 'wp_enqueue_scripts', 'luxury_interior_scripts' );


/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/inc/template-tags.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/inc/customizer.php';

/**
 * Google Fonts
 */
require get_template_directory() . '/inc/gfonts.php';

/**
 * Theme Info Page.
 */
require get_template_directory() . '/inc/addon.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/inc/upgrade-to-pro.php';

/**
 * Webfont-Loader.
 */
require get_template_directory() . '/inc/wptt-webfont-loader.php';

// select
require get_template_directory() . '/inc/select/category-dropdown-custom-control.php';

/**
 * Load TGM.
 */
require get_template_directory() . '/inc/tgm/tgm.php';

if ( ! function_exists( 'luxury_interior_the_custom_logo' ) ) :
/**
 * Displays the optional custom logo.
 *
 * Does nothing if the custom logo is not available.
 *
 */

function luxury_interior_setup_theme() {
	// Footer Link
	define('LUXURY_INTERIOR_FOOTER_LINK',__('https://www.theclassictemplates.com/products/free-interior-design-wordpress-theme','luxury-interior'));

	if ( ! defined( 'LUXURY_INTERIOR_PRO_NAME' ) ) {
		define( 'LUXURY_INTERIOR_PRO_NAME', __( 'About Luxury Interior', 'luxury-interior' ));
	}
	if ( ! defined( 'LUXURY_INTERIOR_THEME_PAGE' ) ) {
	define('LUXURY_INTERIOR_THEME_PAGE',__('https://www.theclassictemplates.com/collections/best-wordpress-templates','luxury-interior'));
	}
	if ( ! defined( 'LUXURY_INTERIOR_SUPPORT' ) ) {
	define('LUXURY_INTERIOR_SUPPORT',__('https://wordpress.org/support/theme/luxury-interior','luxury-interior'));
	}
	if ( ! defined( 'LUXURY_INTERIOR_REVIEW' ) ) {
	define('LUXURY_INTERIOR_REVIEW',__('https://wordpress.org/support/theme/luxury-interior/reviews/','luxury-interior'));
	}
	if ( ! defined( 'LUXURY_INTERIOR_PRO_DEMO' ) ) {
	define('LUXURY_INTERIOR_PRO_DEMO',__('https://live.theclassictemplates.com/demo/luxury-interior','luxury-interior'));
	}
	if ( ! defined( 'LUXURY_INTERIOR_PREMIUM_PAGE' ) ) {
	define('LUXURY_INTERIOR_PREMIUM_PAGE',__('https://www.theclassictemplates.com/products/interior-design-wordpress-theme','luxury-interior'));
	}
	if ( ! defined( 'LUXURY_INTERIOR_THEME_DOCUMENTATION' ) ) {
	define('LUXURY_INTERIOR_THEME_DOCUMENTATION',__('https://live.theclassictemplates.com/demo/docs/luxury-interior-free/','luxury-interior'));
	}
	if ( ! defined( 'LUXURY_INTERIOR_BUNDLE_PAGE' ) ) {
		define('LUXURY_INTERIOR_BUNDLE_PAGE',__('https://www.theclassictemplates.com/products/wordpress-theme-bundle','luxury-interior'));
	}
}
add_action( 'after_setup_theme', 'luxury_interior_setup_theme' );


/* Starter Content */
	add_theme_support( 'starter-content', array(
		'widgets' => array(
			'footer-1' => array(
				'categories',
			),
			'footer-2' => array(
				'archives',
			),
			'footer-3' => array(
				'meta',
			),
			'footer-4' => array(
				'search',
			),
		),
    ));

function luxury_interior_the_custom_logo() {
	if ( function_exists( 'the_custom_logo' ) ) {
		if( has_custom_logo() ){
			the_custom_logo();
		}else{
			echo "<a href='".esc_url( home_url() )."' rel='home'><img src='".esc_url(get_template_directory_uri())."/images/Logo.png' alt='" . esc_attr__("Luxury Interior logo", 'luxury-interior') . "'/></a>";
		}
	}
}
endif;

/*radio button sanitization*/
function luxury_interior_sanitize_choices( $input, $setting ) {
    global $wp_customize;
    $control = $wp_customize->get_control( $setting->id );
    if ( array_key_exists( $input, $control->choices ) ) {
        return $input;
    } else {
        return $setting->default;
    }
}

if ( ! function_exists( 'luxury_interior_sanitize_integer' ) ) {
	function luxury_interior_sanitize_integer( $input ) {
		return (int) $input;
	}
}

function luxury_interior_sanitize_phone_number( $phone ) {
	return preg_replace( '/[^\d+]/', '', $phone );
}

function luxury_interior_sanitize_select( $input, $setting ){
        //input must be a slug: lowercase alphanumeric characters, dashes and underscores are allowed only
        $input = sanitize_key($input);
        //get the list of possible select options
        $choices = $setting->manager->get_control( $setting->id )->choices;
        //return input if valid or return default option
        return ( array_key_exists( $input, $choices ) ? $input : $setting->default );
    }

 function luxury_interior_sanitize_checkbox( $checked ) {
	// Boolean check.
	return ( ( isset( $checked ) && true == $checked ) ? true : false );
}

/* Activation Notice */
function luxury_interior_deprecated_hook_admin_notice() {
    $luxury_interior_theme = wp_get_theme();
    $luxury_interior_dismissed = get_user_meta( get_current_user_id(), 'luxury_interior_dismissable_notice', true );
    if ( !$luxury_interior_dismissed) { ?>
        <div class="getstrat updated notice notice-success is-dismissible notice-get-started-class">
            <div class="admin-image">
                <img src="<?php echo esc_url(get_stylesheet_directory_uri()) .'/screenshot.png'; ?>" />
            </div>
            <div class="admin-content">
                <h1><?php 
				/* translators: 1: Theme name, 2: Theme version. */
				printf( esc_html__( 'Welcome to %1$s %2$s', 'luxury-interior' ), esc_html($luxury_interior_theme->get( 'Name' )), esc_html($luxury_interior_theme->get( 'Version' ))); ?>
                </h1>
                <p><?php _e('Get Started With Theme By Clicking On Getting Started.', 'luxury-interior'); ?></p>
                <div style="display: grid;">
                    <a class="admin-notice-btn button button-hero upgrade-pro" target="_blank" href="<?php echo esc_url( LUXURY_INTERIOR_PREMIUM_PAGE ); ?>"><?php esc_html_e('Upgrade Pro', 'luxury-interior') ?><i class="dashicons dashicons-cart"></i></a>
                    <a class="admin-notice-btn button button-hero" href="<?php echo esc_url( admin_url( 'themes.php?page=luxury-interior' )); ?>"><?php esc_html_e( 'Get started', 'luxury-interior' ) ?><i class="dashicons dashicons-backup"></i></a>
                    <a class="admin-notice-btn button button-hero" target="_blank" href="<?php echo esc_url( LUXURY_INTERIOR_THEME_DOCUMENTATION ); ?>"><?php esc_html_e('Free Doc', 'luxury-interior') ?><i class="dashicons dashicons-visibility"></i></a>
                    <a  class="admin-notice-btn button button-hero" target="_blank" href="<?php echo esc_url( LUXURY_INTERIOR_PRO_DEMO ); ?>"><?php esc_html_e('View Demo', 'luxury-interior') ?><i class="dashicons dashicons-awards"></i></a>
                </div>
            </div>
			<div class="admin-bundle-image">
				<a href="<?php echo esc_url( LUXURY_INTERIOR_BUNDLE_PAGE ); ?>" target="_blank"><img src="<?php echo esc_url(get_stylesheet_directory_uri()) .'/images/image_1.webp'; ?>" /></a>
			</div>
        </div>
    <?php }
}